diff --git a/linux-2.6.37.6-antonio/kernel/fork.c b/linux-2.6.37.6-antonio/kernel/fork.c
index a4913e6..d9abe4b 100644
--- a/linux-2.6.37.6-antonio/kernel/fork.c
+++ b/linux-2.6.37.6-antonio/kernel/fork.c
@@ -1055,6 +1055,12 @@ static struct task_struct *copy_process(unsigned long clone_flags,
 	copy_flags(clone_flags, p);
 	INIT_LIST_HEAD(&p->children);
 	INIT_LIST_HEAD(&p->sibling);
+
+	INIT_HLIST_HEAD(&p->snapshot); /* checkpoint/rollback interface */ //hlist is used in hash list
+//	p->num_snapshot = NULL; /* checkpoint/rollback interface */ // not required is_empty is enough
+	//p->thread_tx = stm_init_thread();
+	p->thread_tx = NULL;
+
 	rcu_copy_process(p);
 	p->vfork_done = NULL;
 	spin_lock_init(&p->alloc_lock);
@@ -1344,431 +1350,6 @@ fork_out:
 	return ERR_PTR(retval);
 }
 
-/*
- * This creates a copy of the data strctures related to a process,
- * and save it in the task descriptor.
- *
- * It copies the registers, and all the appropriate
- * parts of the process environment (as per the clone
- * flags). This function derives from copy_process.
- */
-static struct task_struct *checkpoint_process(unsigned long checkpoint_flags,
-					unsigned long stack_start,
-					struct pt_regs *regs,
-					unsigned long stack_size, /* not sure about this option */
-					int __user *child_tidptr,
-					struct pid *pid,
-					int trace)
-{
-	int retval;
-	struct task_struct *p;
-	int cgroup_callbacks_done = 0;
-
-	// TODO i checkpoint vanno copiati o no durante una fork?!?!
-	//questo si va a ripercuotere su fork e non qui pero
-
-
-//	if ((clone_flags & (CLONE_NEWNS|CLONE_FS)) == (CLONE_NEWNS|CLONE_FS))
-//		return ERR_PTR(-EINVAL);
-
-	/*
-	 * Thread groups must share signals as well, and detached threads
-	 * can only be started up within the thread group.
-	 */
-//	if ((clone_flags & CLONE_THREAD) && !(clone_flags & CLONE_SIGHAND))
-//		return ERR_PTR(-EINVAL);
-
-	/*
-	 * Shared signal handlers imply shared VM. By way of the above,
-	 * thread groups also imply shared VM. Blocking this case allows
-	 * for various simplifications in other code.
-	 */
-//	if ((clone_flags & CLONE_SIGHAND) && !(clone_flags & CLONE_VM))
-//		return ERR_PTR(-EINVAL);
-
-	/*
-	 * Siblings of global init remain as zombies on exit since they are
-	 * not reaped by their parent (swapper). To solve this and to avoid
-	 * multi-rooted process trees, prevent global and container-inits
-	 * from creating siblings.
-	 */
-//	if ((clone_flags & CLONE_PARENT) &&
-//				current->signal->flags & SIGNAL_UNKILLABLE)
-//		return ERR_PTR(-EINVAL);
-
-	// TODO probably also security must be integrated, but not at this point
-//	retval = security_task_create(clone_flags);
-//	if (retval)
-//		goto fork_out;
-
-	retval = -ENOMEM;
-	p = dup_task_struct(current); // duplicate task_struct, thread_info and the stack also
-	if (!p)
-		goto fork_out;
-	// Antonio we do not want to reinit the following stuff
-	p->dirties.shift = current->dirties.shift;
-	p->dirties.period = current->dirties.period;
-	p->dirties.events = current->dirties.events;
-	// continue
-	if (test_tsk_need_resched(current))
-		set_tsk_need_resched(p);
-	// continue
-	atomic_set(&(p->usage), current->usage);
-	atomic_set(&(p->fs_excl), current->fs_excl);
-
-//	ftrace_graph_init_task(p); this cannot be done //in any case nothing to do
-
-//	rt_mutex_init_task(p); this cannot be done
-
-//#ifdef CONFIG_PROVE_LOCKING
-//	DEBUG_LOCKS_WARN_ON(!p->hardirqs_enabled);
-//	DEBUG_LOCKS_WARN_ON(!p->softirqs_enabled);
-//#endif
-//	retval = -EAGAIN;
-//	if (atomic_read(&p->real_cred->user->processes) >=
-//			task_rlimit(p, RLIMIT_NPROC)) {
-//		if (!capable(CAP_SYS_ADMIN) && !capable(CAP_SYS_RESOURCE) &&
-//		    p->real_cred->user != INIT_USER)
-//			goto bad_fork_free;
-//	}
-
-	retval = copy_creds(p, clone_flags); // gestisce clone_thread
-	if (retval < 0)
-		goto bad_fork_free;
-
-	/*
-	 * If multiple threads are within copy_process(), then this check
-	 * triggers too late. This doesn't hurt, the check is only there
-	 * to stop root fork bombs.
-	 */
-	retval = -EAGAIN;
-//	if (nr_threads >= max_threads)
-//		goto bad_fork_cleanup_count;
-
-//	if (!try_module_get(task_thread_info(p)->exec_domain->module))
-//		goto bad_fork_cleanup_count;
-
-	p->did_exec = 0;
-	delayacct_tsk_init(p);	/* Must remain after dup_task_struct() */ //fa nulla
-//	copy_flags(clone_flags, p); // which flags are?!?!? not good for us
-	INIT_LIST_HEAD(&p->children); // on restoring this list must be crosscheck to understand if the same task are alive
-//todo 	hlist_for_each entry copy in the new tsk struct
-	INIT_LIST_HEAD(&p->sibling); // idem as above
-//todo hlist_for_each entry copy in the new tsk struct
-
-	//TODO add this line also in copy_process
-	INIT_LIST_HEAD(&p->checkpoint); // init must be done only on create!!!! not here
-
-	rcu_copy_process(p); // nothing to do in this function
-//	p->vfork_done = NULL;
-//	spin_lock_init(&p->alloc_lock);
-
-//	init_sigpending(&p->pending);
-
-	// cpu time must not be altered also restoring (we do not want to
-	// consider the time from a checkpoint restore but we would ALWAYS knoe
-	// the time from the epoch when the task start
-//	p->utime = cputime_zero;
-//	p->stime = cputime_zero;
-//	p->gtime = cputime_zero;
-//	p->utimescaled = cputime_zero;
-//	p->stimescaled = cputime_zero;
-//#ifndef CONFIG_VIRT_CPU_ACCOUNTING
-//	p->prev_utime = cputime_zero;
-//	p->prev_stime = cputime_zero;
-//#endif
-//#if defined(SPLIT_RSS_COUNTING)
-//	memset(&p->rss_stat, 0, sizeof(p->rss_stat));
-//#endif
-
-//	p->default_timer_slack_ns = current->timer_slack_ns;
-
-	task_io_accounting_init(&p->ioac); // init?!?! canot be copied? -- non fa niente
-	acct_clear_integrals(p); // init?!?! cannot be copied? --- non fa niente
-
-	//posix_cpu_timers_init(p); // this function is expanded below
-	INIT_LIST_HEAD(&p->cpu_timers[0]);
-// TODO	 copy all elements
-	INIT_LIST_HEAD(&p->cpu_timers[1]);
-// TODO	 copy all elements
-	INIT_LIST_HEAD(&p->cpu_timers[2]);
-// TODO	 copy all elements
-
-//	p->lock_depth = -1;		/* -1 = no lock */
-//	do_posix_clock_monotonic_gettime(&p->start_time);
-//	p->real_start_time = p->start_time;
-//	monotonic_to_bootbased(&p->real_start_time);
-//	p->io_context = NULL;
-//	p->audit_context = NULL;
-//?!?!	cgroup_fork(p); // TODO understand what a cgroup_fork is
-#ifdef CONFIG_NUMA
-	p->mempolicy = mpol_dup(p->mempolicy);
- 	if (IS_ERR(p->mempolicy)) {
- 		retval = PTR_ERR(p->mempolicy);
- 		p->mempolicy = NULL;
- 		goto bad_fork_cleanup_cgroup;
- 	}
-	mpol_fix_fork_child_flag(p);
-#endif
-#ifdef CONFIG_TRACE_IRQFLAGS
-	p->irq_events = 0;
-#ifdef __ARCH_WANT_INTERRUPTS_ON_CTXSW
-	p->hardirqs_enabled = 1;
-#else
-	p->hardirqs_enabled = 0;
-#endif
-	p->hardirq_enable_ip = 0;
-	p->hardirq_enable_event = 0;
-	p->hardirq_disable_ip = _THIS_IP_;
-	p->hardirq_disable_event = 0;
-	p->softirqs_enabled = 1;
-	p->softirq_enable_ip = _THIS_IP_;
-	p->softirq_enable_event = 0;
-	p->softirq_disable_ip = 0;
-	p->softirq_disable_event = 0;
-	p->hardirq_context = 0;
-	p->softirq_context = 0;
-#endif
-#ifdef CONFIG_LOCKDEP
-	p->lockdep_depth = 0; /* no locks held yet */
-	p->curr_chain_key = 0;
-	p->lockdep_recursion = 0;
-#endif
-
-#ifdef CONFIG_DEBUG_MUTEXES
-	p->blocked_on = NULL; /* not blocked yet */
-#endif
-#ifdef CONFIG_CGROUP_MEM_RES_CTLR
-	p->memcg_batch.do_batch = 0;
-	p->memcg_batch.memcg = NULL;
-#endif
-
-	/* Perform scheduler related setup. Assign this task to a CPU. */
-//	sched_fork(p, clone_flags); // not required, migrations.. and other stuff we do not want
-	INIT_LIST_HEAD(&p->rt.run_list);
-//TODO	 copy list
-	INIT_LIST_HEAD(&p->se.group_node);
-//TODO	 copy list
-
-//	retval = perf_event_init_task(p);
-//	if (retval)
-//		goto bad_fork_cleanup_policy;
-
-//	if ((retval = audit_alloc(p))) //non fa niente quindi non serve
-//		goto bad_fork_cleanup_policy;
-	/* copy all the process information */
-	if ((retval = copy_semundo(clone_flags, p)))
-		goto bad_fork_cleanup_audit;
-	if ((retval = copy_files(clone_flags, p)))
-		goto bad_fork_cleanup_semundo;
-	if ((retval = copy_fs(clone_flags, p)))
-		goto bad_fork_cleanup_files;
-	if ((retval = copy_sighand(clone_flags, p)))
-		goto bad_fork_cleanup_fs;
-	if ((retval = copy_signal(clone_flags, p)))
-		goto bad_fork_cleanup_sighand;
-	if ((retval = copy_mm(clone_flags, p)))
-		goto bad_fork_cleanup_signal;
-	if ((retval = copy_namespaces(clone_flags, p)))
-		goto bad_fork_cleanup_mm;
-	if ((retval = copy_io(clone_flags, p)))
-		goto bad_fork_cleanup_namespaces;
-	// stack_start and stack_size are IN parameters
-	retval = copy_thread(clone_flags, stack_start, stack_size, p, regs);
-// TODO	not easy this could be used to save pt_regs and also copy TLS (user side, copy could be maintained in kernel)
-	if (retval)
-		goto bad_fork_cleanup_io;
-
-	/* we do not want to create a new pid, but only maintain the current pid and tid.. etc..
-	if (pid != &init_struct_pid) {
-		retval = -ENOMEM;
-		pid = alloc_pid(p->nsproxy->pid_ns);
-		if (!pid)
-			goto bad_fork_cleanup_io;
-
-		if (clone_flags & CLONE_NEWPID) {
-			retval = pid_ns_prepare_proc(p->nsproxy->pid_ns);
-			if (retval < 0)
-				goto bad_fork_free_pid;
-		}
-	}
-
-	p->pid = pid_nr(pid);
-	p->tgid = p->pid;
-	if (clone_flags & CLONE_THREAD)
-		p->tgid = current->tgid;
-	*/
-/*
-	if (current->nsproxy != p->nsproxy) {
-		retval = ns_cgroup_clone(p, pid);
-		if (retval)
-			goto bad_fork_free_pid;
-	}
-*/
-//	p->set_child_tid = (clone_flags & CLONE_CHILD_SETTID) ? child_tidptr : NULL;
-	/*
-	 * Clear TID on mm_release()?
-	 */
-//	p->clear_child_tid = (clone_flags & CLONE_CHILD_CLEARTID) ? child_tidptr: NULL;
-#ifdef CONFIG_FUTEX
-	p->robust_list = NULL;
-#ifdef CONFIG_COMPAT
-	p->compat_robust_list = NULL;
-#endif
-	INIT_LIST_HEAD(&p->pi_state_list);
-	p->pi_state_cache = NULL;
-#endif
-	/*
-	 * sigaltstack should be cleared when sharing the same VM
-	 */
-//	if ((clone_flags & (CLONE_VM|CLONE_VFORK)) == CLONE_VM)
-//		p->sas_ss_sp = p->sas_ss_size = 0;
-
-	/*
-	 * Syscall tracing and stepping should be turned off in the
-	 * child regardless of CLONE_PTRACE.
-	 */
-//	user_disable_single_step(p);
-//	clear_tsk_thread_flag(p, TIF_SYSCALL_TRACE);
-//#ifdef TIF_SYSCALL_EMU
-//	clear_tsk_thread_flag(p, TIF_SYSCALL_EMU);
-//#endif
-//	clear_all_latency_tracing(p);
-
-	/* ok, now we should be set up.. */
-//	p->exit_signal = (clone_flags & CLONE_THREAD) ? -1 : (clone_flags & CSIGNAL);
-//	p->pdeath_signal = 0;
-//	p->exit_state = 0;
-
-	/*
-	 * Ok, make it visible to the rest of the system.
-	 * We dont wake it up yet.
-	 */
-//	p->group_leader = p;
-	INIT_LIST_HEAD(&p->thread_group);
-// TODO add all the list
-
-	/* Now that the task is set up, run cgroup callbacks if
-	 * necessary. We need to run them before the task is visible
-	 * on the tasklist. */
-//	cgroup_fork_callbacks(p);
-//	cgroup_callbacks_done = 1;
-
-	/* Need tasklist lock for parent etc handling! */
-//	write_lock_irq(&tasklist_lock);
-
-	/* CLONE_PARENT re-uses the old parent */
-//	if (clone_flags & (CLONE_PARENT|CLONE_THREAD)) {
-		p->real_parent = current->real_parent;
-		p->parent_exec_id = current->parent_exec_id;
-//	} else {
-//		p->real_parent = current;
-//		p->parent_exec_id = current->self_exec_id;
-//	}
-
-//	spin_lock(&current->sighand->siglock);
-
-	/*
-	 * Process group and session signals need to be delivered to just the
-	 * parent before the fork or both the parent and the child after the
-	 * fork. Restart if a signal comes in before we add the new process to
-	 * it's process group.
-	 * A fatal signal pending means that current will exit, so the new
-	 * thread can't slip out of an OOM kill (or normal SIGKILL).
- 	 */
-/*
-	recalc_sigpending();
-	if (signal_pending(current)) {
-		spin_unlock(&current->sighand->siglock);
-		write_unlock_irq(&tasklist_lock);
-		retval = -ERESTARTNOINTR;
-		goto bad_fork_free_pid;
-	}
-
-	if (clone_flags & CLONE_THREAD) {
-		current->signal->nr_threads++;
-		atomic_inc(&current->signal->live);
-		atomic_inc(&current->signal->sigcnt);
-		p->group_leader = current->group_leader;
-		list_add_tail_rcu(&p->thread_group, &p->group_leader->thread_group);
-	}
-
-	if (likely(p->pid)) {
-		tracehook_finish_clone(p, clone_flags, trace);
-
-		if (thread_group_leader(p)) {
-			if (clone_flags & CLONE_NEWPID)
-				p->nsproxy->pid_ns->child_reaper = p;
-
-			p->signal->leader_pid = pid;
-			p->signal->tty = tty_kref_get(current->signal->tty);
-			attach_pid(p, PIDTYPE_PGID, task_pgrp(current));
-			attach_pid(p, PIDTYPE_SID, task_session(current));
-			list_add_tail(&p->sibling, &p->real_parent->children);
-			list_add_tail_rcu(&p->tasks, &init_task.tasks);
-			__get_cpu_var(process_counts)++;
-		}
-		attach_pid(p, PIDTYPE_PID, pid);
-		nr_threads++;
-	}
-*/ //this is stuff that must be considered when resumpt a thread NOT ON CHECKPOINTING
-//	total_forks++;
-//	spin_unlock(&current->sighand->siglock);
-
-//	write_unlock_irq(&tasklist_lock);
-//	proc_fork_connector(p);
-//	cgroup_post_fork(p);
-//	perf_event_fork(p);
-	return p;
-
-bad_fork_free_pid:
-	if (pid != &init_struct_pid)
-		free_pid(pid);
-bad_fork_cleanup_io:
-	if (p->io_context)
-		exit_io_context(p);
-bad_fork_cleanup_namespaces:
-	exit_task_namespaces(p);
-bad_fork_cleanup_mm:
-	if (p->mm) {
-		task_lock(p);
-		if (p->signal->oom_score_adj == OOM_SCORE_ADJ_MIN)
-			atomic_dec(&p->mm->oom_disable_count);
-		task_unlock(p);
-		mmput(p->mm);
-	}
-bad_fork_cleanup_signal:
-	if (!(clone_flags & CLONE_THREAD))
-		free_signal_struct(p->signal);
-bad_fork_cleanup_sighand:
-	__cleanup_sighand(p->sighand);
-bad_fork_cleanup_fs:
-	exit_fs(p); /* blocking */
-bad_fork_cleanup_files:
-	exit_files(p); /* blocking */
-bad_fork_cleanup_semundo:
-	exit_sem(p);
-bad_fork_cleanup_audit:
-	audit_free(p);
-bad_fork_cleanup_policy:
-	perf_event_free_task(p);
-#ifdef CONFIG_NUMA
-	mpol_put(p->mempolicy);
-bad_fork_cleanup_cgroup:
-#endif
-	cgroup_exit(p, cgroup_callbacks_done);
-	delayacct_tsk_free(p);
-	module_put(task_thread_info(p)->exec_domain->module);
-bad_fork_cleanup_count:
-	atomic_dec(&p->cred->user->processes);
-	exit_creds(p);
-bad_fork_free:
-	free_task(p);
-fork_out:
-	return ERR_PTR(retval);
-}
-
-
 noinline struct pt_regs * __cpuinit __attribute__((weak)) idle_regs(struct pt_regs *regs)
 {
 	memset(regs, 0, sizeof(struct pt_regs));
diff --git a/linux-2.6.37.6-antonio/kernel/sched.c b/linux-2.6.37.6-antonio/kernel/sched.c
index 5e0a919..67833d9 100644
--- a/linux-2.6.37.6-antonio/kernel/sched.c
+++ b/linux-2.6.37.6-antonio/kernel/sched.c
@@ -555,6 +555,9 @@ struct rq {
 
 	/* BKL stats */
 	unsigned int bkl_count;
+#ifdef CONFIG_STM_PREEMPT_AVOIDANCE
+	unsigned int sched_preempt;
+#endif
 #endif
 };
 
diff --git a/linux-2.6.37.6-antonio/kernel/sched_debug.c b/linux-2.6.37.6-antonio/kernel/sched_debug.c
index 2e1b0d1..4f11d4c 100644
--- a/linux-2.6.37.6-antonio/kernel/sched_debug.c
+++ b/linux-2.6.37.6-antonio/kernel/sched_debug.c
@@ -377,7 +377,7 @@ static int __init init_sched_debug_procfs(void)
 }
 
 __initcall(init_sched_debug_procfs);
-
+// in /proc/XXX/sched
 void proc_sched_show_task(struct task_struct *p, struct seq_file *m)
 {
 	unsigned long nr_switches;
@@ -419,6 +419,9 @@ void proc_sched_show_task(struct task_struct *p, struct seq_file *m)
 	P(se.statistics.nr_migrations_cold);
 	P(se.statistics.nr_failed_migrations_affine);
 	P(se.statistics.nr_failed_migrations_running);
+# ifdef CONFIG_STM_MIGRATION_AVOIDANCE
+	P(se.statistics.nr_failed_migrations_stm);
+# endif
 	P(se.statistics.nr_failed_migrations_hot);
 	P(se.statistics.nr_forced_migrations);
 	P(se.statistics.nr_wakeups);
diff --git a/linux-2.6.37.6-antonio/kernel/sched_fair.c b/linux-2.6.37.6-antonio/kernel/sched_fair.c
index 00ebd76..6a5fd92 100644
--- a/linux-2.6.37.6-antonio/kernel/sched_fair.c
+++ b/linux-2.6.37.6-antonio/kernel/sched_fair.c
@@ -1716,6 +1716,33 @@ static struct task_struct *pick_next_task_fair(struct rq *rq)
 	if (!cfs_rq->nr_running)
 		return NULL;
 
+#ifdef CONFIG_STM_PREEMPT_AVOIDANCE
+	/* NOTE
+	 * With this code we assume that the STM application runs
+	 * in the CFS scheduler, this is ok for the prototype
+	 * but is not generic enough. The most important point is
+	 * to do not be preempted by another transactional thread.
+	 * In this way we do not modify the behaviour of the other
+	 * applications/threads (especially much more prioritary then tx)
+	 */
+	p = rq->curr;
+	if (p)
+		if ( (p->thread_tx) ) {
+			if ( ((unsigned long)(p->thread_tx->status) & 0x01) ) {
+# ifdef CONFIG_STM_DEBUG3
+				trace_printk("%s:%d %p %p \n", p->comm, p->pid,
+					p->thread_tx, p->thread_tx->status);
+# endif
+				set_next_entity(cfs_rq, &(p->se));
+				schedstat_inc(rq, sched_preempt);
+# ifdef CONFIG_STM_PREEMPT_BONUS
+				p->thread_tx->bonus++;
+# endif /* CONFIG_STM_PREEMPT_BONUS */
+				return p;
+			}
+		}
+#endif
+
 	do {
 		se = pick_next_entity(cfs_rq);
 		set_next_entity(cfs_rq, se);
@@ -1786,6 +1813,18 @@ int can_migrate_task(struct task_struct *p, struct rq *rq, int this_cpu,
 		return 0;
 	}
 
+#ifdef CONFIG_STM_MIGRATION_AVOIDANCE
+	if ( (p->thread_tx) )
+		if ( ((unsigned long)(p->thread_tx->status) & 0x01) ){
+# ifdef CONFIG_STM_DEBUG3
+			trace_printk("%s:%d %p %p \n", p->comm, p->pid,
+				p->thread_tx, p->thread_tx->status);
+# endif
+			schedstat_inc(p, se.statistics.nr_failed_migrations_stm);
+			return 0;
+		}
+#endif
+
 	/*
 	 * Aggressive migration if:
 	 * 1) task is cache cold, or
diff --git a/linux-2.6.37.6-antonio/kernel/sched_stats.h b/linux-2.6.37.6-antonio/kernel/sched_stats.h
index 48ddf43..ea9f9a1 100644
--- a/linux-2.6.37.6-antonio/kernel/sched_stats.h
+++ b/linux-2.6.37.6-antonio/kernel/sched_stats.h
@@ -26,8 +26,13 @@ static int show_schedstat(struct seq_file *seq, void *v)
 
 		/* runqueue-specific stats */
 		seq_printf(seq,
+#ifndef CONFIG_STM_PREEMPT_AVOIDANCE
 		    "cpu%d %u %u %u %u %u %u %llu %llu %lu",
 		    cpu, rq->yld_count,
+#else
+		    "cpu%d %u %u %u %u %u %u %u %llu %llu %lu",
+		    cpu, rq->yld_count, rq->sched_preempt,
+#endif
 		    rq->sched_switch, rq->sched_count, rq->sched_goidle,
 		    rq->ttwu_count, rq->ttwu_local,
 		    rq->rq_cpu_time,
diff --git a/linux-2.6.37.6-antonio/kernel/trace/Makefile b/linux-2.6.37.6-antonio/kernel/trace/Makefile
index 53f3381..9c2f441 100644
--- a/linux-2.6.37.6-antonio/kernel/trace/Makefile
+++ b/linux-2.6.37.6-antonio/kernel/trace/Makefile
@@ -30,6 +30,7 @@ obj-$(CONFIG_TRACING) += trace_output.o
 obj-$(CONFIG_TRACING) += trace_stat.o
 obj-$(CONFIG_TRACING) += trace_printk.o
 obj-$(CONFIG_CONTEXT_SWITCH_TRACER) += trace_sched_switch.o
+obj-$(CONFIG_CONTEXT_SWITCH_TRACER) += trace_stm.o
 obj-$(CONFIG_FUNCTION_TRACER) += trace_functions.o
 obj-$(CONFIG_IRQSOFF_TRACER) += trace_irqsoff.o
 obj-$(CONFIG_PREEMPT_TRACER) += trace_irqsoff.o
diff --git a/linux-2.6.37.6-antonio/kernel/trace/trace.h b/linux-2.6.37.6-antonio/kernel/trace/trace.h
index 9021f8c..527a209 100644
--- a/linux-2.6.37.6-antonio/kernel/trace/trace.h
+++ b/linux-2.6.37.6-antonio/kernel/trace/trace.h
@@ -29,6 +29,7 @@ enum trace_type {
 	TRACE_GRAPH_ENT,
 	TRACE_USER_STACK,
 	TRACE_BLK,
+	TRACE_STM,
 
 	__TRACE_LAST_TYPE,
 };
@@ -97,6 +98,13 @@ struct kretprobe_trace_entry_head {
 	unsigned long		ret_ip;
 };
 
+struct trace_stm {
+	struct trace_entry	ent;
+	unsigned long tx_addr;
+	int reason;
+	int retry;
+};
+
 /*
  * trace_flag_type is an enumeration that holds different
  * states when a trace occurs. These are:
@@ -197,6 +205,7 @@ extern void __ftrace_bad_type(void);
 			  TRACE_GRAPH_ENT);		\
 		IF_ASSIGN(var, ent, struct ftrace_graph_ret_entry,	\
 			  TRACE_GRAPH_RET);		\
+		IF_ASSIGN(var, ent, struct trace_stm, TRACE_STM); \
 		__ftrace_bad_type();					\
 	} while (0)
 
diff --git a/linux-2.6.37.6-antonio/kernel/trace/trace_stm.c b/linux-2.6.37.6-antonio/kernel/trace/trace_stm.c
new file mode 100644
index 0000000..f93dfeb
--- /dev/null
+++ b/linux-2.6.37.6-antonio/kernel/trace/trace_stm.c
@@ -0,0 +1,177 @@
+/*
+ * ring buffer based C-state tracer
+ *
+ * Arjan van de Ven <arjan@linux.intel.com>
+ * Copyright (C) 2008 Intel Corporation
+ *
+ * Much is borrowed from trace_boot.c which is
+ * Copyright (C) 2008 Frederic Weisbecker <fweisbec@gmail.com>
+ *
+ */
+
+#include <linux/init.h>
+#include <linux/debugfs.h>
+#include <linux/ftrace.h>
+#include <linux/kallsyms.h>
+#include <linux/module.h>
+
+#include "trace.h"
+
+static struct trace_array *stm_trace;
+static int __read_mostly trace_stm_enabled;
+
+
+static void start_stm_trace(void)
+{
+	trace_stm_enabled = 1;
+}
+
+static void stop_stm_trace(struct trace_array *tr)
+{
+	trace_stm_enabled = 0;
+}
+
+static void stm_trace_init(struct trace_array *tr)
+{
+	int cpu;
+	stm_trace = tr;
+
+	trace_stm_enabled = 1;
+
+	for_each_cpu_mask(cpu, cpu_possible_map)
+		tracing_reset(tr, cpu);
+}
+
+static void stm_trace_ctrl_update(struct trace_array *tr)
+{
+/*	if (tr->ctrl)
+		start_stm_trace();
+	else
+		stop_stm_trace(tr);
+		*/
+}
+
+static enum print_line_t stm_print_line(struct trace_iterator *iter)
+{
+	int ret = 0;
+	struct trace_entry *entry = iter->ent;
+	struct trace_stm *field ;
+	struct stm_trace *it;
+	struct trace_seq *s = &iter->seq;
+	struct timespec stamp;
+	struct timespec duration;
+
+	trace_assign_type(field, entry);
+//	it = &field->state_data;
+//	stamp = ktime_to_timespec(it->stamp);
+//	duration = ktime_to_timespec(ktime_sub(it->end, it->stamp));
+
+	if (entry->type == TRACE_STM) {
+			ret = trace_seq_printf(s, "stm_rollback: tx desc @ %ld reason %d retry %s (pid %d cpu %d)\n",
+					field->tx_addr, field->reason,
+					(field->retry) ? "YES" : "NO",
+					  entry->pid, iter->cpu);
+		if (!ret)
+			return TRACE_TYPE_PARTIAL_LINE;
+		return TRACE_TYPE_HANDLED;
+	}
+	return TRACE_TYPE_UNHANDLED;
+}
+
+static struct tracer stm_tracer __read_mostly =
+{
+	.name		= "stm",
+	.init		= stm_trace_init,
+	.reset		= stop_stm_trace,
+//	.ctrl_update	= stm_trace_ctrl_update,
+	.print_line	= stm_print_line,
+};
+
+static int init_stm_trace(void)
+{
+	return register_tracer(&stm_tracer);
+}
+device_initcall(init_stm_trace);
+/*
+// TODO this is start transaction
+void trace_stm_start(struct stm_trace *it, unsigned int type,
+			 unsigned int level)
+{
+	if (!trace_stm_enabled)
+		return;
+
+	memset(it, 0, sizeof(struct power_trace));
+	it->state = level;
+	it->type = type;
+	it->stamp = ktime_get();
+}
+EXPORT_SYMBOL_GPL(trace_power_start);
+*/
+/*
+// TODO this is commit (or end transaction)
+void trace_stm_end(struct stm_trace *it)
+{
+	struct ring_buffer_event *event;
+	struct trace_stm *entry;
+	struct trace_array_cpu *data;
+	unsigned long irq_flags;
+	struct trace_array *tr = stm_trace;
+
+	if (!trace_stm_enabled)
+		return;
+
+	preempt_disable();
+	it->end = ktime_get();
+	data = tr->data[smp_processor_id()];
+
+	event = ring_buffer_lock_reserve(tr->buffer, sizeof(*entry),
+					 &irq_flags);
+	if (!event)
+		goto out;
+	entry	= ring_buffer_event_data(event);
+	tracing_generic_entry_update(&entry->ent, 0, 0);
+	entry->ent.type = TRACE_STM;
+	entry->state_data = *it;
+	ring_buffer_unlock_commit(tr->buffer, event, irq_flags);
+
+	trace_wake_up();
+
+out:
+	preempt_enable();
+}
+EXPORT_SYMBOL_GPL(trace_stm_end);
+*/
+// TODO this is whatever could happen in the middle of a transaction i.e. retry or abort
+void trace_stm_rollback(unsigned long tx_addr, int reason, int retry)
+{
+	struct ring_buffer_event *event;
+	struct trace_stm *entry; //defined in trace.h
+	struct trace_array_cpu *data;
+	unsigned long flags;
+	struct trace_array *tr = stm_trace;
+
+	if (!trace_stm_enabled)
+		return;
+
+	preempt_disable();
+	data = tr->data[smp_processor_id()];
+	local_irq_save(flags);
+	event = ring_buffer_lock_reserve(tr->buffer, sizeof(*entry) );
+					 //,&irq_flags);
+	if (!event)
+		goto out;
+	entry	= ring_buffer_event_data(event);
+	tracing_generic_entry_update(&entry->ent, 0, 0);
+	entry->ent.type = TRACE_STM;
+	entry->tx_addr = tx_addr;
+	entry->reason = reason;
+	entry->retry = retry;
+	ring_buffer_unlock_commit(tr->buffer, event); //, irq_flags);
+
+	trace_wake_up();
+
+ out:
+	preempt_enable();
+	local_irq_restore(flags);
+}
+EXPORT_SYMBOL_GPL(trace_stm_rollback);
